/* Scrutari - Copyright (c) 2008-2011 Vincent Calame - Exemole
 * Logiciel libre donné sous triple licence :
 * 1) selon les termes de la CeCILL V2
 * 2) selon les termes de l’EUPL V.1.1
 * 3) selon les termes de la GNU GPLv3
 * Voir le fichier licences.txt
 */


package fr.exemole.sctserver.servlets.admin;

import fr.exemole.sctserver.SctServer;


/**
 *
 * @author Vincent Calame
 */
public class RestartCommand extends Command {

    public final static String COMMANDNAME = "Restart";
    public final static String COMMANDKEY = "SCT-02";
    public static final String FORCE_PARAMNAME = "force";

    public RestartCommand(SctServer sctServer) {
        super(sctServer);
    }

    protected void doCommand() {
        boolean forceReload = false;
        String forceValue = requestMap.getParameter(FORCE_PARAMNAME);
        if (forceValue != null) {
            if (forceValue.equals("1")) {
                forceReload = true;
            }
        }
        boolean done = sctServer.reload(forceReload);
        if (done) {
            setDone("done_restart", null);
        } else {
            setError("error_reloadprocess", null);
        }
    }

}
