/* Scrutari - Copyright (c) 2009-2011 Vincent Calame - Exemole
 * Logiciel libre donné sous triple licence :
 * 1) selon les termes de la CeCILL V2
 * 2) selon les termes de l’EUPL V.1.1
 * 3) selon les termes de la GNU GPLv3
 * Voir le fichier licences.txt
 */


package fr.exemole.sctserver.servlets.admin.htmlpages.utils;

import fr.exemole.sctserver.admin.OptionsManager;
import fr.exemole.sctserver.admin.SearchLogDeny;
import fr.exemole.sctserver.servlets.admin.htmlpages.AdminHtmlPage;
import fr.exemole.sctserver.servlets.resources.theme.SctCssCatalog;
import net.mapeadores.util.conditions.ConditionUtils;
import net.mapeadores.util.conditions.TextTest;
import net.mapeadores.util.html.HTMLAttributes;


/**
 *
 * @author Vincent Calame
 */
public class SearchLogFilterPrinter implements SctCssCatalog {

    private SearchLogFilterPrinter() {
    }

    public static void printSearchLogFilter(AdminHtmlPage page) {
        OptionsManager optionsManager = page.getSctServer().getOptionsManager();
        int count = optionsManager.getSearchLogDenyCount();
        if (count == 0) {
            page.startP();
            page.startEm();
            page.localize("info_searchlogfilter_none");
            page.endEm();
            page.endP();
        } else {
            HTMLAttributes tableAttributes = new HTMLAttributes();
            tableAttributes.addClass(TABLE_SEARCHLOGFILTER);
            page.startTable(tableAttributes);
            page.startRow();
            page.startCell();
            page.append("IP");
            page.endCell();
            page.startCell();
            page.append("SITE");
            page.endCell();
            page.startCell();
            page.append("REF");
            page.endCell();
            page.endRow();
            for (int i = 0; i < count; i++) {
                printSearchLogDenyRow(page, optionsManager.getSearchLogDeny(i));
            }
            page.endTable();
        }
    }

    private static void printSearchLogDenyRow(AdminHtmlPage page, SearchLogDeny searchLogDeny) {
        page.startRow();
        printTextTest(page, searchLogDeny.getTextTest(searchLogDeny.IP_DENY));
        printTextTest(page, searchLogDeny.getTextTest(SearchLogDeny.SITE_DENY));
        printTextTest(page, searchLogDeny.getTextTest(SearchLogDeny.REF_DENY));
        page.endRow();
    }

    private static void printTextTest(AdminHtmlPage page, TextTest testText) {
        if (testText == null) {
            page.appendEmptyCell();
        } else {
            page.startCell();
            page.escape(ConditionUtils.textTestToString(testText));
            page.endCell();
        }
    }

}
