/* Scrutari - Copyright (c) 2008-2011 Vincent Calame - Exemole
 * Logiciel libre donné sous triple licence :
 * 1) selon les termes de la CeCILL V2
 * 2) selon les termes de l’EUPL V.1.1
 * 3) selon les termes de la GNU GPLv3
 * Voir le fichier licences.txt
 */


package fr.exemole.sctserver.servlets.explore.htmlpages;

import fr.exemole.sctserver.SctServer;
import net.mapeadores.scrutari.supermotcle.Supermotcle;
import net.mapeadores.scrutari.supermotcle.SupermotcleManager;
import net.mapeadores.scrutari.supermotcle.SupermotcleMap;
import java.io.IOException;
import java.util.List;
import javax.servlet.http.HttpServletResponse;
import net.mapeadores.util.text.SearchSequence;


/**
 *
 * @author Vincent Calame
 */
public class SupermotcleListePage extends ExploreHtmlPage {

    private int libLangInteger;
    private SearchSequence searchSequence;

    public SupermotcleListePage(SctServer sctServer, int libLangInteger, SearchSequence searchSequence) {
        super(sctServer);
        this.libLangInteger = libLangInteger;
    }

    public void handleResponse(HttpServletResponse response) throws IOException {
        SupermotcleManager supermotcleManager = sctServer.getSupermotcleManager();
        SupermotcleMap supermotcleMap = supermotcleManager.getSupermotcleMap(libLangInteger);
        initResponse(response);
        start();
        if (supermotcleMap == null) {
            escape("Rien pour cette langue");
        } else {
            printSupermotcleMap(supermotcleMap);
        }
        end();
    }

    private void printSupermotcleMap(SupermotcleMap supermotcleMap) throws IOException {
        List<Supermotcle> list = supermotcleMap.getSupermotcleList(searchSequence);
        for (Supermotcle supermotcle : list) {
            append(String.valueOf(supermotcle.getCode()));
            append(";");
            escape(supermotcle.getCollationUnit().getSourceString());
            append(";");
            append(String.valueOf(supermotcle.getCodemotcleList().getCodeCount()));
            append(";");
            append(String.valueOf(supermotcle.getIndexationCount()));
            /*append("|");
            List list2 = supermotcle.getCodemotcleList();
            for(Iterator it2 = list2.iterator(); it2.hasNext();) {
            Integer itg = (Integer) it2.next();
            append(itg.toString());
            append("|");
            }*/
            appendBr();
        }
    }

}
