/* Scrutari - Copyright (c) 2009-2011 Vincent Calame - Exemole
 * Logiciel libre donné sous triple licence :
 * 1) selon les termes de la CeCILL V2
 * 2) selon les termes de l’EUPL V.1.1
 * 3) selon les termes de la GNU GPLv3
 * Voir le fichier licences.txt
 */


package fr.exemole.sctserver.servlets.global.htmlpages;

import fr.exemole.sctserver.servlets.ScrutariContext;
import net.mapeadores.util.html.HTMLAttributes;
import net.mapeadores.util.html.UtilHtmlPrinter;
import net.mapeadores.util.localisation.BundleLocalisation;
import net.mapeadores.util.localisation.ResourceLocalisation;
import net.mapeadores.util.servlets.ResponseHandler;
import java.io.IOException;
import java.util.Locale;
import java.util.ResourceBundle;
import javax.servlet.http.HttpServletResponse;
import net.mapeadores.util.localisation.LocalisationInfo;


/**
 *
 * @author Vincent Calame
 */
public abstract class GlobalHtmlPage extends UtilHtmlPrinter implements ResponseHandler {

    protected ScrutariContext scrutariContext;
    protected int workingLangInteger;

    public GlobalHtmlPage() {
    }

    protected void init(ScrutariContext scrutariContext, LocalisationInfo localisationInfo) {
        this.scrutariContext = scrutariContext;
        this.workingLangInteger = localisationInfo.getWorkingLangInteger();
        Locale locale = localisationInfo.getFormatLocale();
        ResourceLocalisation textResourceLocalisation = new BundleLocalisation(ResourceBundle.getBundle("fr.exemole.sctserver.servlets.resources.l10n.sctadmin", locale));
        addResourceLocalisation(textResourceLocalisation);
    }

    public long getLastModified() {
        return ResponseHandler.LASTMODIFIED_NOCACHE;
    }

    protected void initResponse(HttpServletResponse response) throws IOException {
        response.setContentType("text/html;charset=UTF-8");
        initPrinter(response.getWriter());

    }

    public void start() {
        setIconPng("icon.png");
        addCssUrl("global.css");
        setTitle("Scrutari");
        start(workingLangInteger);
        HTMLAttributes divAttributes = new HTMLAttributes();
        divAttributes.setId("BLOC_GLOBAL");
        startDiv(divAttributes);
        divAttributes.setId("BLOC_LOGO");
        startDiv(divAttributes);
        HTMLAttributes htmlAttributes = new HTMLAttributes();
        htmlAttributes.setSrc("logo.png");
        appendImg(htmlAttributes);
        endDiv();
        divAttributes.setId("BLOC_CORPS");
        startDiv(divAttributes);
    }

    public void end() {
        endDiv();
        endDiv();
        super.end();
    }

}
