/* Scrutari - Copyright (c) 2009-2011 Vincent Calame - Exemole
 * Logiciel libre donné sous triple licence :
 * 1) selon les termes de la CeCILL V2
 * 2) selon les termes de l’EUPL V.1.1
 * 3) selon les termes de la GNU GPLv3
 * Voir le fichier licences.txt
 */


package fr.exemole.sctserver.servlets.global.htmlpages;

import fr.exemole.sctserver.servlets.ScrutariContext;
import net.mapeadores.util.html.HTMLAttributes;
import java.io.IOException;
import java.util.List;
import javax.servlet.http.HttpServletResponse;
import net.mapeadores.util.localisation.LocalisationInfo;


/**
 *
 * @author Vincent Calame
 */
public class ListPage extends GlobalHtmlPage {

    public ListPage(ScrutariContext scrutariContext, LocalisationInfo localisationInfo) {
        init(scrutariContext, localisationInfo);
    }

    public void handleResponse(HttpServletResponse response) throws IOException {
        initResponse(response);
        start();
        HTMLAttributes pAttributes = new HTMLAttributes();
        pAttributes.setClasses("p_Titre");
        startP(pAttributes);
        localize("global_maj");
        endP();
        if (scrutariContext.hasError()) {
            pAttributes.setClasses("p_Signal");
            startP(pAttributes);
            localize("global_error");
            endP();
            pAttributes.setClasses("p_Erreur");
            startP(pAttributes);
            localize(scrutariContext.getErrorKey());
            endP();
        }
        List<String> nameList = scrutariContext.getNameList();
        int size = nameList.size();
        pAttributes.setClasses("p_Introliste");
        startP(pAttributes);
        if (size == 0) {
            localize("global_serveur_aucun");
        } else if (size == 1) {
            localize("global_serveur_un");
        } else {
            localize("global_serveur_plusieurs", new Integer(size));
        }
        endP();
        if (size > 0) {
            startUl();
            for (String name : nameList) {
                startLi();
                escape(name);
                endLi();
            }
            endUl();
        }
        end();
    }

}
