/* ScrutariLib_DB - Copyright (c) 2010-2012 Vincent Calame - Exemole
 * Logiciel libre donné sous triple licence :
 * 1) selon les termes de la CeCILL V2
 * 2) selon les termes de l’EUPL V.1.1
 * 3) selon les termes de la GNU GPLv3
 * Voir le fichier licences.txt
 */


package net.mapeadores.scrutari.db;

import net.mapeadores.scrutari.data.BaseData;
import net.mapeadores.scrutari.data.CorpusData;
import net.mapeadores.scrutari.data.ThesaurusData;
import net.mapeadores.scrutari.data.MotcleData;
import net.mapeadores.scrutari.data.FicheData;
import net.scrutari.datauri.ScrutariDataURI;


/**
 *
 * @author Vincent Calame
 */
public interface DataAccess {

    public int getBaseCount();

    public int getCorpusCount();

    public int getThesaurusCount();

    public int getCode(ScrutariDataURI scrutariDataURI);

    /**
     * La nature de l'objet dépend de la classe de scrutariDataURI
     * BaseURi = BaseData, CorpusURI = CorpusData, ThesaurusURI = thesaurusData, FicheURI = ficheData, MotcleURI = MotcleData
     */
    public Object getScrutariData(ScrutariDataURI scrutariDataURI);

    public BaseData getBaseDataByCode(int codebase);

    public BaseData getBaseDataByIndex(int index);

    public CorpusData getCorpusDataByCode(int codecorpus);

    public CorpusData getCorpusDataByIndex(int index);

    public CodeList getCodecorpusList();

    public ThesaurusData getThesaurusDataByCode(int codethesaurus);

    public ThesaurusData getThesaurusDataByIndex(int index);

    public CodeList getCodethesaurusList();

    public MotcleData getMotcleDataByCode(int codemotcle);

    public FicheData getFicheDataByCode(int codefiche);

    public int getFicheDateIntegerByCode(int codefiche);

    public IndexationCodeList getIndexationCodeList(int elementCode, int subsetCode);

    public void close();
}
