/* ScrutariLib_DB - Copyright (c) 2010-2011 Vincent Calame - Exemole
 * Logiciel libre donné sous triple licence :
 * 1) selon les termes de la CeCILL V2
 * 2) selon les termes de l’EUPL V.1.1
 * 3) selon les termes de la GNU GPLv3
 * Voir le fichier licences.txt
 */


package net.mapeadores.scrutari.db.codefilter;

import java.util.ArrayList;
import java.util.List;
import net.mapeadores.scrutari.db.CodeList;


/**
 *
 * @author Vincent Calame
 */
public class MultiCodeConditionBuilder {

    private short globalCondition;
    private List<CodeList> codeLists = new ArrayList<CodeList>();

    public MultiCodeConditionBuilder(short globalCondition) {
        this.globalCondition = globalCondition;
    }

    public short getGlobalCondition() {
        return globalCondition;
    }

    public void add(CodeList codeList) {
        codeLists.add(codeList);
    }

    public MultiCodeCondition toMultiCodeCondition() {
        int size = codeLists.size();
        CodeList[] codeListArray = new CodeList[size];
        for (int i = 0; i < size; i++) {
            codeListArray[i] = codeLists.get(i);
        }
        return new InternalMultiCodeCondition(globalCondition, codeListArray);
    }


    private static class InternalMultiCodeCondition implements MultiCodeCondition {

        private short globalCondition;
        private CodeList[] codeListArray;

        private InternalMultiCodeCondition(short globalCondition, CodeList[] codeListArray) {
            this.globalCondition = globalCondition;
            this.codeListArray = codeListArray;
        }

        public short getGlobalCondition() {
            return globalCondition;
        }

        public int getCodeListCount() {
            return codeListArray.length;
        }

        public CodeList getCodeList(int i) {
            return codeListArray[i];
        }

    }

}
