/* ScrutariLib_Data - Copyright (c) 2005-2008 Vincent Calame - Exemole
 * Logiciel libre donné sous triple licence :
 * 1) selon les termes de la CeCILL V2
 * 2) selon les termes de l’EUPL V.1.1
 * 3) selon les termes de la GNU GPLv3
 * Voir le fichier licences.txt
 */


package net.mapeadores.scrutari.data;

import net.mapeadores.util.exceptions.SwitchException;


/**
 *
 * @author Vincent Calame
 */
public class TypeConstants {

    public static final short UNKNOWN_TYPE = 0;
    public static final short CNC_TYPE = 1;
    public static final short EXP_TYPE = 2;
    public static final short ANA_TYPE = 3;
    public static final short ENT_TYPE = 4;
    public static final short LEC_TYPE = 5;
    public static final short BIP_TYPE = 6;
    public static final short BBL_TYPE = 7;
    public static final short CPT_TYPE = 8;

    private TypeConstants() {
    }

    public static short typeToShort(String s) {
        if (s.equals("CNC")) {
            return CNC_TYPE;
        } else if (s.equals("EXP")) {
            return EXP_TYPE;
        } else if (s.equals("ANA")) {
            return ANA_TYPE;
        } else if (s.equals("ENT")) {
            return ENT_TYPE;
        } else if (s.equals("LEC")) {
            return LEC_TYPE;
        } else if (s.equals("BIP")) {
            return BIP_TYPE;
        } else if (s.equals("BBL")) {
            return BBL_TYPE;
        } else if (s.equals("CPT")) {
            return CPT_TYPE;
        } else {
            throw new IllegalArgumentException("unknown type = " + s);
        }
    }

    public static String typeToString(short type) {
        switch (type) {
            case CNC_TYPE:
                return "CNC";
            case EXP_TYPE:
                return "EXP";
            case ANA_TYPE:
                return "ANA";
            case ENT_TYPE:
                return "ENT";
            case LEC_TYPE:
                return "LEC";
            case BIP_TYPE:
                return "BIP";
            case BBL_TYPE:
                return "BBL";
            case CPT_TYPE:
                return "CPT";

            default:
                throw new SwitchException("type = " + type);
        }
    }

}
