/* ScrutariLib_Lexie - Copyright (c) 2008-2012 Vincent Calame - Exemole
 * Logiciel libre donné sous triple licence :
 * 1) selon les termes de la CeCILL V2
 * 2) selon les termes de l’EUPL V.1.1
 * 3) selon les termes de la GNU GPLv3
 * Voir le fichier licences.txt
 */


package net.mapeadores.scrutari.lexie;

import java.io.IOException;
import java.util.HashMap;
import java.util.Map;
import net.mapeadores.util.primitives.io.PrimitivesReader;
import net.mapeadores.util.primitives.io.PrimitivesWriter;


/**
 *
 * @author Vincent Calame
 */
public class FicheLexification {

    private Map<Integer, Lexification> map = new HashMap<Integer, Lexification>();

    public FicheLexification() {
    }

    public Lexification getLexification(int fieldNumber) {
        return map.get(fieldNumber);
    }

    public void putLexification(int fieldNumber, Lexification lexification) {
        map.put(fieldNumber, lexification);
    }

    public static FicheLexification fromPrimitives(PrimitivesReader primitivesReader) throws IOException {
        FicheLexification ficheLexification = new FicheLexification();
        int size = primitivesReader.readInt();
        for (int i = 0; i < size; i++) {
            int fieldNumber = primitivesReader.readInt();
            Lexification lexification = Lexification.fromPrimitives(primitivesReader);
            ficheLexification.putLexification(fieldNumber, lexification);
        }
        return ficheLexification;
    }

    public static void toPrimitives(FicheLexification ficheLexification, PrimitivesWriter primitivesWriter) throws IOException {
        Map<Integer, Lexification> map = ficheLexification.map;
        int size = map.size();
        primitivesWriter.writeInt(size);
        for (Map.Entry<Integer,Lexification> entry : map.entrySet()) {
            primitivesWriter.writeInt(entry.getKey());
            Lexification.toPrimitives(entry.getValue(), primitivesWriter);
        }
    }

}
