/* ScrutariLib_Lexie - Copyright (c) 2008-2012 Vincent Calame - Exemole
 * Logiciel libre donné sous triple licence :
 * 1) selon les termes de la CeCILL V2
 * 2) selon les termes de l’EUPL V.1.1
 * 3) selon les termes de la GNU GPLv3
 * Voir le fichier licences.txt
 */


package net.mapeadores.scrutari.lexie;

import java.io.IOException;
import java.util.HashMap;
import java.util.Map;
import net.mapeadores.util.primitives.io.PrimitivesReader;
import net.mapeadores.util.primitives.io.PrimitivesWriter;


/**
 *
 * @author Vincent Calame
 */
public class MotcleLexification {

    private Map<Integer, Lexification> map = new HashMap<Integer, Lexification>();

    public MotcleLexification() {
    }

    public Lexification getLexification(int langInteger) {
        return map.get(langInteger);
    }

    public void putLexification(int langInteger, Lexification lexification) {
        map.put(langInteger, lexification);
    }

    public static MotcleLexification fromPrimitives(PrimitivesReader primitivesReader) throws IOException {
        MotcleLexification motcleLexification = new MotcleLexification();
        int size = primitivesReader.readInt();
        for (int i = 0; i < size; i++) {
            int fieldNumber = primitivesReader.readInt();
            Lexification lexification = Lexification.fromPrimitives(primitivesReader);
            motcleLexification.putLexification(fieldNumber, lexification);
        }
        return motcleLexification;
    }

    public static void toPrimitives(MotcleLexification motcleLexification, PrimitivesWriter primitivesWriter) throws IOException {
        Map<Integer, Lexification> map = motcleLexification.map;
        int size = map.size();
        primitivesWriter.writeInt(size);
        for (Map.Entry<Integer, Lexification> entry : map.entrySet()) {
            primitivesWriter.writeInt(entry.getKey());
            Lexification.toPrimitives(entry.getValue(), primitivesWriter);
        }
    }

}
