/* ScrutariLib_SearchEngine - Copyright (c) 2008-2011 Vincent Calame - Exemole
 * Logiciel libre donné sous triple licence :
 * 1) selon les termes de la CeCILL V2
 * 2) selon les termes de l’EUPL V.1.1
 * 3) selon les termes de la GNU GPLv3
 * Voir le fichier licences.txt
 */


package net.mapeadores.scrutari.searchengine;


/**
 *
 * @author Vincent Calame
 */
public interface MotcleSearchResultInfo {

    /**
     * Retourne le code de la i-ième fiche.
     */
    public int getAcceptedFicheCode(int i);

    /**
     * Retourne le nombre de fiches finalement acceptées indexées par le mot-clé.
     */
    public int getAcceptedFicheCount();

    /**
     * Retourne le code du mot-clé.
     */
    public int getCode();

    /**
     * Retourne le nombre maximum de fiches susceptibles d'être associées suivant 
     * les options de recherche. Autrement dit, c'est le nombre total de fiches
     * indexées par le mot-clé dans les corpus et bases sélectionnées.
     */
    public int getFicheMaximum();

    public int getMotcleSearchTokenPositionListCount();

    public MotcleSearchTokenPositionList getMotcleSearchTokenPositionList(int i);

    /**
     * Retourne la liste des instances de SubstringPosition indiquant la présence de mots
     * de la recherche dans le libellé de langue langInteger.
     * Retourne <em>null</em> si le libellé dans la langue donnée n'a pas participé à la
     * recherche. L'instance de  SearchTokenPositionList retourné est donc soit nul, soit de taille supérieur à 0.
     */
    public SearchTokenPositionList getSearchTokentPositionListByLang(int langInteger);

}
