/* ScrutariLib_SearchEngine - Copyright (c) 2011 Vincent Calame - Exemole
 * Logiciel libre donné sous triple licence :
 * 1) selon les termes de la CeCILL V2
 * 2) selon les termes de l’EUPL V.1.1
 * 3) selon les termes de la GNU GPLv3
 * Voir le fichier licences.txt
 */


package net.mapeadores.scrutari.searchengine.impl;

import net.mapeadores.scrutari.searchengine.FicheSearchResult;
import net.mapeadores.scrutari.searchengine.FicheSearchResultGroup;
import net.mapeadores.scrutari.searchengine.MotcleSearchResultInfo;
import net.mapeadores.util.langinteger.LangInteger;
import net.mapeadores.util.text.SearchSequence;


/**
 *
 * @author Vincent Calame
 */
public class MutableFicheSearchResult implements FicheSearchResult {

    private String identifiant;
    private SearchSequence searchSequence;
    private int langUi = LangInteger.UNDETERMINED;
    private int[] langIntegerArray;
    private int ficheCount;
    private int ficheMaximum;
    private int motcleCount;
    private int completeMotcleCount;
    private FicheSearchResultGroup[] ficheSearchResultGroupArray;
    private MotcleSearchResultInfo[] motcleSearchResultInfoArray;

    public String getIdentifiant() {
        return identifiant;
    }

    public SearchSequence getSearchSequence() {
        return searchSequence;
    }

    public int[] getLangIntegerArray() {
        return langIntegerArray;
    }

    public int getLangUi() {
        return langUi;
    }

    public int getFicheCount() {
        return ficheCount;
    }

    public int getFicheMaximum() {
        return ficheMaximum;
    }

    public int getMotcleCount() {
        return motcleCount;
    }

    public int getCompleteMotcleCount() {
        return completeMotcleCount;
    }

    public int getFicheSearchResultGroupCount() {
        if (ficheSearchResultGroupArray == null) {
            return 0;
        }
        return ficheSearchResultGroupArray.length;
    }

    public FicheSearchResultGroup getFicheSearchResultGroup(int i) {
        return ficheSearchResultGroupArray[i];
    }

    public MotcleSearchResultInfo getMotcleResult(int i) {
        return motcleSearchResultInfoArray[i];
    }

    public void setIdentifiant(String identifiant) {
        this.identifiant = identifiant;
    }

    public void setSearchSequence(SearchSequence searchSequence) {
        this.searchSequence = searchSequence;
    }

    public void setLangIntegerArray(int[] langIntegerArray) {
        this.langIntegerArray = langIntegerArray;
    }

    public void setLangUi(int langUi) {
        this.langUi = langUi;
    }

    public void setCompleteMotcleCount(int completeMotcleCount) {
        this.completeMotcleCount = completeMotcleCount;
    }

    public void setFicheMaximum(int ficheMaximum) {
        this.ficheMaximum = ficheMaximum;
    }

    public void setFicheCount(int ficheCount) {
        this.ficheCount = ficheCount;
    }

    public void setMotcleCount(int motcleCount) {
        this.motcleCount = motcleCount;
    }

    public void setFicheSearchResultGroupArray(FicheSearchResultGroup[] ficheSearchResultGroupArray) {
        this.ficheSearchResultGroupArray = ficheSearchResultGroupArray;
    }

    public void setMotcleSearchResultInfoArray(MotcleSearchResultInfo[] motcleSearchResultInfoArray) {
        this.motcleSearchResultInfoArray = motcleSearchResultInfoArray;
    }

}
