/* ScrutariLib_SearchEngine - Copyright (c) 2011 Vincent Calame - Exemole
 * Logiciel libre donné sous triple licence :
 * 1) selon les termes de la CeCILL V2
 * 2) selon les termes de l’EUPL V.1.1
 * 3) selon les termes de la GNU GPLv3
 * Voir le fichier licences.txt
 */


package net.mapeadores.scrutari.searchengine.impl;

import net.mapeadores.scrutari.searchengine.FicheSearchResultInfo;
import net.mapeadores.scrutari.searchengine.FicheSearchTokenPositionList;


/**
 *
 * @author Vincent Calame
 */
public class MutableFicheSearchResultInfo implements FicheSearchResultInfo {

    private int code;
    private int[] motcleCodeArray = null;
    private FicheSearchTokenPositionList[] ficheSearchTokenPositionListArray;
    private float pertinence;

    public MutableFicheSearchResultInfo() {
    }

    public int getCode() {
        return code;
    }

    public int getMotcleCount() {
        if (motcleCodeArray == null) {
            return 0;
        }
        return motcleCodeArray.length;
    }

    public int getMotcleCode(int i) {
        return motcleCodeArray[i];
    }

    public int getFicheSearchTokenPositionListCount() {
        if (ficheSearchTokenPositionListArray == null) {
            return 0;
        }
        return ficheSearchTokenPositionListArray.length;
    }

    public FicheSearchTokenPositionList getFicheSearchTokenPositionList(int i) {
        return ficheSearchTokenPositionListArray[i];
    }

    public FicheSearchTokenPositionList getSubstringPositionList(int fieldNumber) {
        if (ficheSearchTokenPositionListArray == null) {
            return null;
        }
        int count = ficheSearchTokenPositionListArray.length;
        for (int i = 0; i < count; i++) {
            FicheSearchTokenPositionList ficheSearchTokenPositionList = ficheSearchTokenPositionListArray[i];
            if (ficheSearchTokenPositionList.getFieldNumber() == fieldNumber) {
                return ficheSearchTokenPositionList;
            }
        }
        return null;
    }

    public void setCode(int code) {
        this.code = code;
    }

    public void setMotcleCodeArray(int[] motcleCodeArray) {
        this.motcleCodeArray = motcleCodeArray;
    }

    public void setFicheSearchTokenPositionListArray(FicheSearchTokenPositionList[] ficheSearchTokenPositionListArray) {
        this.ficheSearchTokenPositionListArray = ficheSearchTokenPositionListArray;
    }

    public float getPertinence() {
        return pertinence;
    }

    public void setPertinence(float pertinence) {
        this.pertinence = pertinence;
    }

}
