/* ScrutariLib_SearchEngine - Copyright (c) 2011 Vincent Calame - Exemole
 * Logiciel libre donné sous triple licence :
 * 1) selon les termes de la CeCILL V2
 * 2) selon les termes de l’EUPL V.1.1
 * 3) selon les termes de la GNU GPLv3
 * Voir le fichier licences.txt
 */


package net.mapeadores.scrutari.searchengine.impl;

import net.mapeadores.scrutari.searchengine.MotcleSearchResultInfo;
import net.mapeadores.scrutari.searchengine.MotcleSearchTokenPositionList;
import net.mapeadores.scrutari.searchengine.SearchTokenPositionList;


/**
 *
 * @author Vincent Calame
 */
public class MutableMotcleSearchResultInfo implements MotcleSearchResultInfo {

    private int code;
    private int ficheMaximum;
    private int[] acceptedFicheCodeArray;
    private MotcleSearchTokenPositionList[] motcleSearchTokenPositionListArray;

    public MutableMotcleSearchResultInfo() {
    }

    public int getCode() {
        return code;
    }

    public int getAcceptedFicheCount() {
        if (acceptedFicheCodeArray == null) {
            return 0;
        }
        return acceptedFicheCodeArray.length;
    }

    public int getAcceptedFicheCode(int i) {
        return acceptedFicheCodeArray[i];
    }

    public int getFicheMaximum() {
        return ficheMaximum;
    }

    public int getMotcleSearchTokenPositionListCount() {
        if (motcleSearchTokenPositionListArray == null) {
            return 0;
        }
        return motcleSearchTokenPositionListArray.length;
    }

    public MotcleSearchTokenPositionList getMotcleSearchTokenPositionList(int i) {
        return motcleSearchTokenPositionListArray[i];
    }

    public SearchTokenPositionList getSearchTokentPositionListByLang(int langInteger) {
        if (motcleSearchTokenPositionListArray == null) {
            return null;
        }
        int length = motcleSearchTokenPositionListArray.length;
        for (int i = 0; i < length; i++) {
            MotcleSearchTokenPositionList motcleSearchTokenPositionList = motcleSearchTokenPositionListArray[i];
            if (motcleSearchTokenPositionList.getLangInteger() == langInteger) {
                return motcleSearchTokenPositionList;
            }
        }
        return null;
    }

    public void setCode(int code) {
        this.code = code;
    }

    public void setFicheMaximum(int ficheMaximum) {
        this.ficheMaximum = ficheMaximum;
    }

    public void setAcceptedFicheCodeArray(int[] acceptedFicheCodeArray) {
        this.acceptedFicheCodeArray = acceptedFicheCodeArray;
    }

    public void setMotcleSearchTokenPositionListArray(MotcleSearchTokenPositionList[] motcleSearchTokenPositionListArray) {
        this.motcleSearchTokenPositionListArray = motcleSearchTokenPositionListArray;
    }

}
