/* ScrutariLib_SearchEngine - Copyright (c) 2010-2011 Vincent Calame - Exemole
 * Logiciel libre donné sous triple licence :
 * 1) selon les termes de la CeCILL V2
 * 2) selon les termes de l’EUPL V.1.1
 * 3) selon les termes de la GNU GPLv3
 * Voir le fichier licences.txt
 */


package net.mapeadores.scrutari.searchengine.util;

import net.mapeadores.util.text.SubstringPosition;
import net.mapeadores.scrutari.searchengine.impl.SearchTokenPosition;


/**
 *
 * @author Vincent Calame
 */
public class SearchTokenPositionArrayBuilder {

    private SubstringPosition[] positionArray;
    private int[] tokenIndices;
    private int size = 0;

    public SearchTokenPositionArrayBuilder(int tokenCount) {
        positionArray = new SubstringPosition[tokenCount];
        tokenIndices = new int[tokenCount];
    }

    public void add(int tokenIndex, SubstringPosition substringPosition) {
        boolean insert = false;
        for (int i = 0; i < size; i++) {
            if (substringPosition.compareTo(positionArray[i]) < 0) {
                System.arraycopy(positionArray, i, positionArray, i + 1, size - i);
                System.arraycopy(tokenIndices, i, tokenIndices, i + 1, size - i);
                tokenIndices[i] = tokenIndex;
                positionArray[i] = substringPosition;
                insert = true;
                break;
            }
        }
        if (!insert) {
            tokenIndices[size] = tokenIndex;
            positionArray[size] = substringPosition;
        }
        size++;
    }

    public SearchTokenPosition[] getSearchTokenPositionArray() {
        SearchTokenPosition[] searchTokenPositionArray = new SearchTokenPosition[size];
        for (int i = 0; i < size; i++) {
            SearchTokenPosition searchTokenPosition = new SearchTokenPosition();
            searchTokenPosition.setSearchTokenIndex(tokenIndices[i]);
            searchTokenPosition.setSubstringPosition(positionArray[i]);
            searchTokenPositionArray[i] = searchTokenPosition;
        }
        return searchTokenPositionArray;
    }

    public boolean isAllTokens() {
        return (size == positionArray.length);
    }

}
