/* SctServer - Copyright (c) 2007 Vincent Calame - Exemole
 * Logiciel libre donné sous triple licence :
 * 1) selon les termes de la CeCILL V2
 * 2) selon les termes de l’EUPL V.1.1
 * 3) selon les termes de la GNU GPLv3
 * Voir le fichier licences.txt
 */


package fr.exemole.sctserver.request;


/**
 *
 * @author Vincent Calame
 */
public class RequestInfo {

    private String remoteAddress;
    private boolean withLog = true;
    private String site;
    private String referrer;

    public RequestInfo(String remoteAddress, boolean withLog, String site, String referrer) {
        this.remoteAddress = checkString(remoteAddress);
        this.withLog = withLog;
        this.site = checkString(site);
        this.referrer = checkString(referrer);
    }

    /**
     * Nul ou de longueur non nulle
     */
    public String getRemoteAddress() {
        return remoteAddress;
    }

    public boolean withLog() {
        return withLog;
    }

    /**
     * Nul ou de longueur non nulle
     */
    public String getSite() {
        return site;
    }

    /**
     * Nul ou de longueur non nulle
     */
    public String getReferrer() {
        return referrer;
    }

    private String checkString(String s) {
        if (s == null) {
            return null;
        }
        s = s.trim();
        if (s.length() == 0) {
            return null;
        }
        return s;
    }

}
