/* SctServer - Copyright (c) 2011 Vincent Calame - Exemole
 * Logiciel libre donné sous triple licence :
 * 1) selon les termes de la CeCILL V2
 * 2) selon les termes de l’EUPL V.1.1
 * 3) selon les termes de la GNU GPLv3
 * Voir le fichier licences.txt
 */


package fr.exemole.sctserver.request;

import java.util.ArrayList;
import java.util.List;


/**
 *
 * @author Vincent Calame
 */
public class WarningHandler {

    private String currentParameter;
    private List<Warning> warningList = new ArrayList<Warning>();

    public boolean isEmpty() {
        return (warningList.isEmpty());
    }

    public void setCurrentParameter(String parameter) {
        this.currentParameter = parameter;
    }

    public void addWarning(String warningKey, String value) {
        warningList.add(new Warning(currentParameter, warningKey, value));
    }

    public int getWarningCount() {
        return warningList.size();
    }

    public Warning getWarning(int i) {
        return warningList.get(i);
    }


    public static class Warning {

        private String warningParameter;
        private String warningKey;
        private String warningValue;

        private Warning(String warningParameter, String warningKey, String warningValue) {
            this.warningParameter = warningParameter;
            this.warningKey = warningKey;
            this.warningValue = warningValue;
        }

        public String getWarningParameter() {
            return warningParameter;
        }

        public String getWarningKey() {
            return warningKey;
        }

        public String getWarningValue() {
            return warningValue;
        }

    }

}
