/* SctServer - Copyright (c) 2009-2011 Vincent Calame - Exemole
 * Logiciel libre donné sous triple licence :
 * 1) selon les termes de la CeCILL V2
 * 2) selon les termes de l’EUPL V.1.1
 * 3) selon les termes de la GNU GPLv3
 * Voir le fichier licences.txt
 */


package fr.exemole.sctserver.request.simple.catalog;

import fr.exemole.sctserver.SctServer;
import net.mapeadores.scrutari.searchengine.CorpusClasse;
import fr.exemole.sctserver.admin.OptionsManager;
import fr.exemole.sctserver.request.simple.SimpleRequest;
import java.io.IOException;
import java.io.PrintWriter;
import net.mapeadores.scrutari.searchengine.GlobalSearchOptions;


/**
 *
 * @author Vincent Calame
 */
public class ClasseRequest extends SimpleRequest {

    private int uiLangInteger;
    private OptionsManager optionsManager;

    public ClasseRequest(SctServer sctServer, int uiLangInteger) {
        super(sctServer.getScrutariDB());
        optionsManager = sctServer.getOptionsManager();
        this.uiLangInteger = uiLangInteger;
    }

    public void printResponse(PrintWriter pw) throws IOException {
        GlobalSearchOptions globalSearchOptions = optionsManager.getGlobalSearchOptions();
        int classeCount = globalSearchOptions.getCorpusClasseCount();
        for (int i = 0; i < classeCount; i++) {
            CorpusClasse corpusClasse = globalSearchOptions.getCorpusClasse(i);
            printCorpusClasse(pw, corpusClasse);
        }

    }

    private void printCorpusClasse(PrintWriter pw, CorpusClasse corpusClasse) throws IOException {
        pw.print("#c");
        pw.print('\n');
        pw.print("clval=");
        pw.print(corpusClasse.getRank());
        pw.print('\n');
        String lib = corpusClasse.getLibelleString(uiLangInteger, false);
        if (lib == null) {
            lib = String.valueOf(corpusClasse.getRank());
        }
        pw.print("cllib=");
        pw.print(lib);
        pw.print('\n');
    }

}
