/* SctServer - Copyright (c) 2007-2012 Vincent Calame - Exemole
 * Logiciel libre donné sous triple licence :
 * 1) selon les termes de la CeCILL V2
 * 2) selon les termes de l’EUPL V.1.1
 * 3) selon les termes de la GNU GPLv3
 * Voir le fichier licences.txt
 */


package fr.exemole.sctserver.request.simple.catalog;

import net.mapeadores.scrutari.db.CodeList;
import net.mapeadores.scrutari.db.ScrutariDB;
import net.mapeadores.scrutari.db.util.DataUtils;
import fr.exemole.sctserver.request.simple.SimpleRequest;
import java.io.IOException;
import java.io.PrintWriter;
import net.mapeadores.scrutari.db.DataAccess;


/**
 *
 * @author Vincent Calame
 */
public class TotalParBaseRequest extends SimpleRequest {

    private int[] langIntegerArray;
    private CodeList basecodeList;

    public TotalParBaseRequest(ScrutariDB scrutariDB, CodeList basecodeList, int[] langIntegerArray) {
        super(scrutariDB);
        this.langIntegerArray = langIntegerArray;
        this.basecodeList = basecodeList;
    }

    public void printResponse(PrintWriter pw) throws IOException {
        DataAccess dataAccess = scrutariDB.openDataAccess();
        pw.print(DataUtils.getFicheCountByBase(dataAccess, basecodeList, langIntegerArray));
        dataAccess.close();
    }

}
