/* SctServer - Copyright (c) 2008-2012 Vincent Calame - Exemole
 * Logiciel libre donné sous triple licence :
 * 1) selon les termes de la CeCILL V2
 * 2) selon les termes de l’EUPL V.1.1
 * 3) selon les termes de la GNU GPLv3
 * Voir le fichier licences.txt
 */


package fr.exemole.sctserver.storage;

import fr.exemole.sctserver.admin.ScrutariInfo;
import fr.exemole.sctserver.conf.ConfDirectory;
import java.io.InputStream;
import java.util.Date;
import net.mapeadores.scrutari.db.DataCacheWriter;
import net.mapeadores.scrutari.db.LexieCacheWriter;
import net.mapeadores.scrutari.db.ScrutariDBName;
import net.mapeadores.scrutari.searchengine.FicheSearchResult;
import net.scrutari.datauri.tree.URITree;


/**
 *
 * @author Vincent Calame
 */
public interface SctServerStorage {

    /**
     * Peut retourner null.
     */
    public InputStream getScrutariData(ScrutariInfo scrutariInfo);

    public void saveScrutariData(ScrutariInfo scrutariInfo, InputStream inputStream);

    public FicheSearchResult getFicheSearchResult(String identifiant);

    public void saveFicheSearchResult(FicheSearchResult ficheSearchResult);

    public LogAccess getLogAccess();

    public SearchLogAccess getSearchLogAccess();

    public void clean();

    public void cleanSearchResults();

    public ConfDirectory getConfDirectory();

    public void saveURITree(URITree uriTree, ScrutariDBName scrutariDBName);

    public URITree getURITree(Date date);

    /**
     * Dates de la plus récente à la plus ancienne
     */
    public Date[] getAddURITreeDateArray();

    public DataCacheWriter getDataCacheWriter(ScrutariDBName scrutariDbName);

    public LexieCacheWriter getLexieCacheWriter(ScrutariDBName scrutariDbName);

    public void clearCache(ScrutariDBName scrutariDbName);

}
